VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   Caption         =   "UFO Unit Maker"
   ClientHeight    =   5535
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6855
   LinkTopic       =   "Form1"
   ScaleHeight     =   5535
   ScaleWidth      =   6855
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox comboUnitType 
      Height          =   315
      ItemData        =   "frmMain3.frx":0000
      Left            =   1200
      List            =   "frmMain3.frx":0002
      Style           =   2  'Dropdown List
      TabIndex        =   13
      Top             =   360
      Width           =   4335
   End
   Begin VB.TextBox txtOutputFile 
      Height          =   285
      Left            =   1200
      TabIndex        =   12
      Text            =   "Text1"
      Top             =   1080
      Width           =   4335
   End
   Begin VB.CommandButton cmdOutputFile 
      Caption         =   "Open..."
      Height          =   315
      Left            =   5640
      TabIndex        =   11
      Top             =   1080
      Width           =   1095
   End
   Begin VB.ComboBox comboOutputSeq 
      Height          =   315
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   10
      Top             =   2040
      Width           =   5175
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Create Output Sequence (overwrites any existing files)"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   1440
      Width           =   6615
   End
   Begin VB.FileListBox lstFiles 
      Height          =   285
      Left            =   5760
      TabIndex        =   8
      Top             =   120
      Visible         =   0   'False
      Width           =   615
   End
   Begin VB.ComboBox comboWeapon 
      Height          =   315
      Left            =   1200
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   720
      Width           =   4335
   End
   Begin VB.Frame framePal 
      Caption         =   "Conversion Palette"
      Height          =   3015
      Left            =   3120
      TabIndex        =   0
      Top             =   2400
      Width           =   3615
      Begin VB.OptionButton optPal 
         Caption         =   "No conversion (assumes all parts of each frame have the same palette)"
         Height          =   495
         Index           =   0
         Left            =   240
         TabIndex        =   6
         Top             =   240
         Value           =   -1  'True
         Width           =   3255
      End
      Begin VB.OptionButton optPal 
         Caption         =   "combo.pal (you need to generate this first)"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   5
         Top             =   1080
         Width           =   3255
      End
      Begin VB.OptionButton optPal 
         Caption         =   "ra2.pal"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   4
         Top             =   720
         Width           =   1335
      End
      Begin VB.CheckBox cboxRemapClose 
         Caption         =   "Remappable colours eligible for conversion (nearest match)."
         Height          =   375
         Left            =   120
         TabIndex        =   3
         Top             =   1440
         Width           =   3255
      End
      Begin VB.CheckBox cboxRemapExact 
         Caption         =   "Remappable colours eligible for conversion if they match exactly."
         Height          =   375
         Left            =   120
         TabIndex        =   2
         Top             =   1920
         Width           =   3255
      End
      Begin VB.CheckBox cboxRA2BG 
         Caption         =   "Convert UFO background color to RA2."
         Height          =   375
         Left            =   120
         TabIndex        =   1
         Top             =   2520
         Value           =   1  'Checked
         Width           =   3255
      End
   End
   Begin MSComDlg.CommonDialog dialogOpen 
      Left            =   6360
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "bmp"
      DialogTitle     =   "Select bitmap file"
      Filter          =   "Bitmap Files (*.bmp)|*.bmp"
      Flags           =   4
   End
   Begin VB.Label Label2 
      Caption         =   "Unit Type:"
      Height          =   255
      Left            =   120
      TabIndex        =   18
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label7 
      Caption         =   "Output File:"
      Height          =   255
      Left            =   120
      TabIndex        =   17
      Top             =   1080
      Width           =   1095
   End
   Begin VB.Image imageOutput 
      Appearance      =   0  'Flat
      BorderStyle     =   1  'Fixed Single
      Height          =   2895
      Left            =   120
      Top             =   2520
      Width           =   2895
   End
   Begin VB.Label Label9 
      Caption         =   "Output Sequence:"
      Height          =   255
      Left            =   120
      TabIndex        =   16
      Top             =   2040
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "Weapon:"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   720
      Width           =   1095
   End
   Begin VB.Label Label5 
      Caption         =   "Warning! No validation"
      ForeColor       =   &H00000080&
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   120
      Width           =   5415
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim EXEDIR As String
Dim RESDIR As String
Dim ProfileINI As String
Dim ProfileOLD As String
Dim ProfileCount As Integer
Dim NullBitmap As String
Private Type ProfileType
    Name As String
    SourceFile As String
    UnitType As Integer
    Weapon As Integer
    WeaponOffsetY As Integer
    OutputFile As String
End Type
Dim ProfileNum As Integer
Dim Profile() As ProfileType
Dim UsedColors() As RGB
Dim UsedColorsProximity() As Double

Const UnitTypeXCom As Integer = 0
Const UnitTypeSnakeman As Integer = 1
Const UnitTypeFloater As Integer = 2
Const UnitTypeEthereal As Integer = 3
Const UnitTypeChrysalid As Integer = 4
Const UnitTypeZombie As Integer = 5
Const UnitTypeCelatid As Integer = 6
Const UnitTypeSilacoid As Integer = 7
Const UnitTypeSectoid As Integer = 8

Const StateDeath As Integer = 0
Const StateStand As Integer = 1
Const StateCrouch As Integer = 2
Const StateShoot As Integer = 3
Const StateCrouchShoot As Integer = 4
Const StateMarch As Integer = 5
Const StateDead As Integer = 6
Const StateFlying As Integer = 7
Const StateFlyingShoot As Integer = 8

Const UnitXShirtF As Integer = 0
Const UnitXShirtM As Integer = 1
Const UnitXArmorF As Integer = 2
Const UnitXArmorM As Integer = 3
Const UnitXPower As Integer = 4
Const UnitXFlying As Integer = 5
Const UnitSnakeman As Integer = 6
Const UnitFloater As Integer = 7
Const UnitEthereal As Integer = 8
Const UnitChrysalid As Integer = 9
Const UnitZombie As Integer = 10
Const UnitCelatid As Integer = 11
Const UnitSilacoid As Integer = 12
Const UnitSectoid As Integer = 13
Const UnitMuton As Integer = 14
Const UnitCivilianF As Integer = 15
Const UnitCivilianM As Integer = 16
Const UnitCount As Integer = 17
Dim UnitFile(UnitCount) As String
Dim UnitName(UnitCount) As String

Const WeaponNone As Integer = 0
Const WeaponPistol As Integer = 1
Const WeaponRifle As Integer = 2
Const WeaponAutoCannon As Integer = 3
Const WeaponHeavyCannon As Integer = 4
Const WeaponRocketLauncher As Integer = 5
Const WeaponStunRod As Integer = 6
Const WeaponGrenade As Integer = 7
Const WeaponLaserPistol As Integer = 8
Const WeaponLaserRifle As Integer = 9
Const WeaponHeavyLaser As Integer = 10
Const WeaponPlasmaPistol As Integer = 11
Const WeaponPlasmaRifle As Integer = 12
Const WeaponHeavyPlasma As Integer = 13
Const WeaponSmallLauncher As Integer = 14
Const WeaponBlasterLauncher As Integer = 15
Const WeaponPsiAmp As Integer = 16
Const WeaponCount = 17
Dim WeaponType(WeaponCount) As Integer
Dim WeaponName(WeaponCount) As String

Const WeaponTypeUnarmed As Integer = 0
Const WeaponTypePistol As Integer = 1
Const WeaponTypeHeavy As Integer = 2

Private Function AddWeapon(ByVal sName As String, ByVal iWeapon As Integer, ByVal iType As Integer)
    Call comboWeapon.AddItem(sName, iWeapon)
    WeaponType(iWeapon) = iType
    WeaponName(iWeapon) = sName
End Function

Private Function AddUnit(ByVal sName As String, ByVal iUnit As Integer, ByVal sFile As String)
    Call comboUnitType.AddItem(sName, iUnit)
    UnitFile(iUnit) = sFile
    UnitName(iUnit) = sName
End Function

Private Function Init()
    EXEDIR = App.Path
    RESDIR = JoinPath(EXEDIR, "Resources")
    ProfileINI = JoinPath(EXEDIR, "Profiles.ini")
    ProfileOLD = JoinPath(EXEDIR, "Profiles.old")
    NullBitmap = JoinPath(EXEDIR, "Null.bmp")
    Call AddUnit("X-Com Shirt Female", UnitXShirtF, "xcom_1\XCOM_")
    Call AddUnit("X-Com Shirt Male", UnitXShirtM, "xcom_1\XCOM_")
    Call AddUnit("X-Com Personal Armor Female", UnitXArmorF, "xcom_0\XCOM_")
    Call AddUnit("X-Com Personal Armor Male", UnitXArmorM, "xcom_0\XCOM_")
    Call AddUnit("X-Com Power Suit", UnitXPower, "xcom_2\XCOM_")
    Call AddUnit("X-Com Flying Suit", UnitXFlying, "xcom_2\XCOM_")
    Call AddUnit("Snakeman", UnitSnakeman, "snakeman\SNAKE")
    Call AddUnit("Floater", UnitFloater, "float\FLOAT")
    Call AddUnit("Ethereal", UnitEthereal, "ethereal\ETHER")
    Call AddUnit("Chrysalid", UnitChrysalid, "chrysalid\CHRYS")
    Call AddUnit("Zombie", UnitZombie, "zombie\ZOMBI")
    Call AddUnit("Celatid", UnitCelatid, "celatid\CELAT")
    Call AddUnit("Silacoid", UnitSilacoid, "silacoid\SILAC")
    Call AddUnit("Sectoid", UnitSectoid, "sectoid\SECTO")
    Call AddUnit("Muton", UnitMuton, "muton\MUTON")
    Call AddUnit("CivilianF", UnitCivilianF, "civf\CIVF")
    Call AddUnit("CivilianM", UnitCivilianM, "civm\CIVM")
    Call AddWeapon("None", WeaponNone, WeaponTypeUnarmed)
    Call AddWeapon("Pistol", WeaponPistol, WeaponTypePistol)
    Call AddWeapon("Rifle", WeaponRifle, WeaponTypeHeavy)
    Call AddWeapon("AutoCannon", WeaponAutoCannon, WeaponTypeHeavy)
    Call AddWeapon("HeavyCannon", WeaponHeavyCannon, WeaponTypeHeavy)
    Call AddWeapon("RocketLauncher", WeaponRocketLauncher, WeaponTypeHeavy)
    Call AddWeapon("StunRod", WeaponStunRod, WeaponTypePistol)
    Call AddWeapon("Grenade", WeaponGrenade, WeaponTypePistol)
    Call AddWeapon("LaserPistol", WeaponLaserPistol, WeaponTypePistol)
    Call AddWeapon("LaserRifle", WeaponLaserRifle, WeaponTypeHeavy)
    Call AddWeapon("HeavyLaser", WeaponHeavyLaser, WeaponTypeHeavy)
    Call AddWeapon("PlasmaPistol", WeaponPlasmaPistol, WeaponTypePistol)
    Call AddWeapon("PlasmaRifle", WeaponPlasmaRifle, WeaponTypeHeavy)
    Call AddWeapon("HeavyPlasma", WeaponHeavyPlasma, WeaponTypeHeavy)
    Call AddWeapon("SmallLauncher", WeaponSmallLauncher, WeaponTypePistol)
    Call AddWeapon("BlasterLauncher", WeaponBlasterLauncher, WeaponTypeHeavy)
    Call AddWeapon("PsiAmp", WeaponPsiAmp, WeaponTypePistol)
    txtOutputFile.Text = JoinPath(EXEDIR, "Output")
End Function

Private Function TextBGColor(ByVal Enable As Boolean) As Long
    If Enable Then
        TextBGColor = &H80000005
    Else
        TextBGColor = &H8000000F
    End If
End Function

Private Sub cmdClone_Click()
    Call CloneProfile
End Sub

Private Sub cmdDelete_Click()
    Call DeleteProfile
End Sub

Private Sub cmdGo_Click()
   'Call CreateHumanoid
   Call CreateSequence(comboUnitType.ListIndex, comboWeapon.ListIndex)
   Call UpdateOutputSequence
   comboOutputSeq.ListIndex = 1
   Call comboOutputSeq.SetFocus
End Sub

Private Function GetUnitFile(ByVal iUnit, ByVal iFrame) As String
    If iFrame <> -1 Then
        GetUnitFile = JoinPath(RESDIR, UnitFile(iUnit) & PadNum(iFrame, 3) & ".BMP")
    Else
        GetUnitFile = JoinPath(RESDIR, UnitFile(iUnit) & "_DEAD.BMP")
    End If
End Function

Private Function GetWeaponFile(ByVal iWeapon, ByVal iFacing, Optional ByVal bShoot As Boolean = False) As String
    iFacing = iFacing + 1
    If bShoot And WeaponType(iWeapon) = WeaponTypeHeavy Then
        Select Case iFacing
        Case 7, 8: GetWeaponFile = JoinPath(RESDIR, "weapons\" & WeaponName(iWeapon) & PadNum(iFacing - 6, 3) & ".bmp")
        Case Else: GetWeaponFile = JoinPath(RESDIR, "weapons\" & WeaponName(iWeapon) & PadNum(iFacing + 2, 3) & ".bmp")
        End Select
    Else
        GetWeaponFile = JoinPath(RESDIR, "weapons\" & WeaponName(iWeapon) & PadNum(iFacing, 3) & ".bmp")
    End If
End Function

Private Function CreateSequence(ByVal iUnit As Integer, ByVal iWeapon As Integer)
    Dim iAnimFrame As Integer
    Dim iState As Integer
    Dim iOutputFrame As Integer
    Dim iFacing As Integer
    Dim FinalImage As MarshallxImageClass
    
    'standing still
    iState = StateStand
    For iFacing = 0 To 7
        Call CreateUnit1Frame(iUnit, iFacing, iState, 0, iWeapon, FinalImage)
        Call SaveImage(FinalImage, 7 - iFacing)
    Next iFacing
End Function

Private Sub SaveImage(OutImage As MarshallxImageClass, ByVal iOutFrame As Integer)
    Dim iCounter As Integer
    Dim ConvertPaletteAllowedSlots() As Integer
    Call OutImage.SizeCanvas(94, 106)
    Call OutImage.OffsetImage(31, 21) '+FullBodyBobOffset
    'convert palette
    'first, limit the source palette to VGA values (that's all RA2 can have)
    Call OutImage.LimitPaletteToVGA
    Call OutImage.SavePalette(JoinPath(App.Path, "vga_ufo.pal"), "JASC") 'TEMPORARY!
    'conversion options - what palette slots can we match against?
    ReDim ConvertPaletteAllowedSlots(255)
    For iCounter = 0 To 15
        ConvertPaletteAllowedSlots(iCounter) = PaletteMatchNone
    Next iCounter
    For iCounter = 16 To 31
        If cboxRemapClose.Value = 1 Then
            ConvertPaletteAllowedSlots(iCounter) = PaletteMatchAll
        ElseIf cboxRemapExact.Value = 1 Then
            ConvertPaletteAllowedSlots(iCounter) = PaletteMatchExact
        Else
            ConvertPaletteAllowedSlots(iCounter) = PaletteMatchNone
        End If
    Next iCounter
    For iCounter = 240 To 255
        ConvertPaletteAllowedSlots(iCounter) = PaletteMatchNone
    Next iCounter
    For iCounter = 32 To 239
        ConvertPaletteAllowedSlots(iCounter) = PaletteMatchAll
    Next iCounter
    If optPal(1).Value = True Then
        'ra2 palette
        Call OutImage.LoadPalette(JoinPath(App.Path, "ra2.pal"), ConvertPaletteAllowedSlots(), "JASC", ConvertMethodNearestColor)
    ElseIf optPal(2).Value = True Then
        'combo palette
        Call OutImage.LoadPalette(JoinPath(App.Path, "combo.pal"), ConvertPaletteAllowedSlots(), "JASC", ConvertMethodNearestColor)
    End If
    If cboxRA2BG.Value = 1 Then Call OutImage.SetBackgroundColorByIndex(0, True)
    'save the completed frame
    Call OutImage.SaveBMP(Left$(txtOutputFile.Text, Len(txtOutputFile.Text) - 8) & PadNum(iOutFrame, 4) & ".bmp")
End Sub

Private Sub LoadAndInitBMP(ByVal sFile As String, image As MarshallxImageClass)
    Call image.LoadBMP(sFile)
    Call image.SetBackgroundColorByIndex(254)
    image.TransparentColor = image.BackgroundColor
    'Call image.SizeCanvas(32, 40)
End Sub

Private Sub CreateUnit1Frame(ByVal iUnit As Integer, ByVal iFacing As Integer, ByVal iState As Integer, ByVal iAnimFrame As Integer, ByVal iWeapon As Integer, FinalImage As MarshallxImageClass)
'Death animation has 3 frames of 3 images = 9 anim frames total
    Dim iTorsoFrame As Integer
    Dim iArm1 As Integer
    Dim iArm2 As Integer
    Dim iHandObjectY As Integer
    Dim bShoot As Boolean
    Dim iBobOffset As Integer
    Dim TempImage As MarshallxImageClass
    Dim iAnimPad As Integer
    Set TempImage = New MarshallxImageClass
    Set FinalImage = New MarshallxImageClass
    
    'init the new frame
    Call FinalImage.LoadBMP(GetUnitFile(iUnit, 1)) 'any file will do to get the palette
    Call FinalImage.SetBackgroundColorByIndex(254)
    Call FinalImage.ClearCanvas
    Call FinalImage.SizeCanvas(32, 40)

    If iState = StateDeath Then
        iAnimPad = 3
        Select Case iUnit
        Case UnitFloater: Call LoadAndInitBMP(GetUnitFile(iUnit, 65 + (iAnimFrame / iAnimPad)), TempImage)
        Case UnitSnakeman: Call LoadAndInitBMP(GetUnitFile(iUnit, 97 + (iAnimFrame / iAnimPad)), TempImage)
        Case UnitEthereal: Call LoadAndInitBMP(GetUnitFile(iUnit, 73 + (iAnimFrame / iAnimPad)), TempImage)
        Case UnitChrysalid: Call LoadAndInitBMP(GetUnitFile(iUnit, 225 + (iAnimFrame / iAnimPad)), TempImage)
        Case UnitZombie: Call LoadAndInitBMP(GetUnitFile(iUnit, 73 + iAnimFrame), TempImage)
        Case Else: Call LoadAndInitBMP(GetUnitFile(iUnit, 265 + (iAnimFrame / iAnimPad)), TempImage)
        End Select
        FinalImage = TempImage
        Exit Sub
    End If

    If iState = StateDead Then
        'generate dead body anims
        If FileExists(GetUnitFile(iUnit, -1)) Then
            'generate initial dead body - later on we will manually create the decompose frames (or maybe a future version of this program will do it)
            Call LoadAndInitBMP(GetUnitFile(iUnit, -1), TempImage)
        End If
        FinalImage = TempImage
        Exit Sub
    End If
    
    'more initing
    iTorsoFrame = 33 'the first torso frame
    iArm1 = 0
    iArm2 = 0
    iHandObjectY = 0
    bShoot = False
    If iState = StateCrouchShoot Or iState = StateShoot Then bShoot = True
    
    'adjust which arm is drawn first based on facing
    If iFacing < 4 Then
        iArm2 = 1
    Else
        iArm1 = 1
    End If
    
    If iState = StateCrouch Or iState = StateCrouchShoot Then iHandObjectY = iHandObjectY + 4
    
    If iUnit = UnitSectoid Then iHandObjectY = iHandObjectY + 6
    
    'the start of the hand animations when holding items
    If WeaponType(iWeapon) <> WeaponTypeUnarmed Then
        If iState <> StateMarch Then
            Select Case iUnit
            Case UnitFloater
                iArm1 = iArm1 + 8
                iArm2 = iArm2 + 8
            Case UnitSnakeman
                iArm1 = iArm1 + 13
                iArm2 = iArm2 + 13
            Case Else
                iArm1 = iArm1 + 30
                iArm2 = iArm2 + 30
            End Select
        End If
    End If

    'full body bobbing for flying units. If you don't want the unit to bob while flying, then just reference the first frame in the unit's InfantrySequence
    If iState = StateFlying Then
        Select Case iAnimFrame
        Case 0: iBobOffset = 0
        Case 1: iBobOffset = 1
        Case 2: iBobOffset = 2
        Case 3: iBobOffset = 1
        Case 4: iBobOffset = 0
        Case 5: iBobOffset = -1
        End Select
    End If

    'if facing away from the camera, draw the weapons first
    If iFacing < 1 Or iFacing > 5 Then
        'i'm not convinced that this is precise enough, but we'll see. I think we might need to put an arm first for some facings
        Call LoadAndInitBMP(GetWeaponFile(iWeapon, iFacing, bShoot), TempImage)
        Call TempImage.OffsetImage(0, iHandObjectY + iBobOffset)
        Call FinalImage.Superimpose(TempImage, True)
    End If
    
    Select Case iState
    Case StateCrouch, StateCrouchShoot
        'first arm
        Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm1) + iFacing), TempImage)
        Call TempImage.OffsetImage(0, 4)
        Call FinalImage.Superimpose(TempImage, True)
        'head/torso
        Call LoadAndInitBMP(GetUnitFile(iUnit, iTorsoFrame + iFacing), TempImage)
        Call TempImage.OffsetImage(0, 4)
        Call FinalImage.Superimpose(TempImage, True)
        'legs
        Select Case iUnit
        Case UnitSectoid: Call LoadAndInitBMP(GetUnitFile(iUnit, (16 * 4 + 8) + iFacing), TempImage)
        Case UnitMuton: Call LoadAndInitBMP(GetUnitFile(iUnit, (16 * 4 + 0) + iFacing), TempImage)
        Case Else: Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * 3) + iFacing), TempImage)
        End Select
        Call FinalImage.Superimpose(TempImage, True)
        'last arm
        Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm2) + iFacing), TempImage)
        Call TempImage.OffsetImage(0, 4)
        Call FinalImage.Superimpose(TempImage, True)

    Case StateStand, StateFlying:
        'first arm
        Select Case iUnit
        Case UnitSnakeman
            If WeaponType(iWeapon) <> WeaponTypeUnarmed Then
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm1) + iFacing + 3), TempImage)
            Else
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm1) + iFacing), TempImage)
            End If
        Case Else
            Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm1) + iFacing), TempImage)
        End Select
        Call TempImage.OffsetImage(0, iBobOffset)
        Call FinalImage.Superimpose(TempImage, True)
        'head/torso
        Call LoadAndInitBMP(GetUnitFile(iUnit, iTorsoFrame + iFacing), TempImage)
        Call TempImage.OffsetImage(0, iBobOffset)
        Call FinalImage.Superimpose(TempImage, True)
        'legs
        If iState = StateFlying Then
            Call LoadAndInitBMP(GetUnitFile(iUnit, 275 + iFacing), TempImage)
            Call TempImage.OffsetImage(0, iBobOffset)
        Else
            Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * 2) + iFacing), TempImage)
        End If
        Call FinalImage.Superimpose(TempImage, True)
        'last arm
        Select Case iUnit
        Case UnitSnakeman
            If WeaponType(iWeapon) <> WeaponTypeUnarmed Then
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm2) + iFacing + 3), TempImage)
            Else
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm2) + iFacing), TempImage)
            End If
        Case Else
            Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm2) + iFacing), TempImage)
        End Select
        Call TempImage.OffsetImage(0, iBobOffset)
        Call FinalImage.Superimpose(TempImage, True)
        
    Case StateMarch
        'bob offset (head, and sometimes arms, move up and down as the creature walks)
        Select Case iUnit
        Case UnitSnakeman
            Select Case iAnimFrame
            Case 0: iBobOffset = 3
            Case 1: iBobOffset = 3
            Case 2: iBobOffset = 2
            Case 3: iBobOffset = 2
            Case 4: iBobOffset = 1
            Case 5: iBobOffset = 1
            Case 6: iBobOffset = 2
            Case 7: iBobOffset = 3
            End Select
        Case Else
            If iAnimFrame Mod 4 = 0 Then
                iBobOffset = -1
            ElseIf iAnimFrame Mod 2 = 1 Then
                iBobOffset = 0
            Else
                iBobOffset = 2
            End If
        End Select

        'further adjustments to arm selection / first arm
        If WeaponType(iWeapon) <> WeaponTypeUnarmed Then
            Select Case iUnit
            'Case UnitFloater
            '    iArm1 = iArm1 + 8
            '    iArm2 = iArm2 + 8
            Case UnitSnakeman
                iArm1 = iArm1 + 13
                iArm2 = iArm2 + 13
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm1) + iFacing) + 3, TempImage)
                Call TempImage.OffsetImage(0, iBobOffset)
            Case Else
                iArm1 = iArm1 + 30
                iArm2 = iArm2 + 30
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm1) + iFacing), TempImage)
            End Select
        Else
            Select Case iUnit
            'Case UnitFloater
            '    iArm1 = iArm1 + 8
            '    iArm2 = iArm2 + 8
            Case UnitSnakeman
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm1) + iFacing), TempImage)
                Call TempImage.OffsetImage(0, iBobOffset)
            Case Else
                Call LoadAndInitBMP(GetUnitFile(iUnit, iAnimFrame + ((iFacing * 3) + 7 - 1 - iArm2) * 8), TempImage)
                Call TempImage.OffsetImage(0, iBobOffset)
            End Select
        End If
        
        'head/torso
        Call LoadAndInitBMP(GetUnitFile(iUnit, iTorsoFrame + iFacing), TempImage)
        If iUnit = UnitSnakeman Then 'really?! is this really only for snakeman....?
            Call TempImage.OffsetImage(0, iBobOffset)
        End If
        Call FinalImage.Superimpose(TempImage, True)

        'legs
        If iState = StateFlying Then
            Call LoadAndInitBMP(GetUnitFile(iUnit, 275 + iFacing), TempImage)
        Else
            Call LoadAndInitBMP(GetUnitFile(iUnit, iAnimFrame + ((iFacing * 3) + 7) * 8), TempImage)
            Call TempImage.OffsetImage(0, iBobOffset)
        End If
        Call FinalImage.Superimpose(TempImage, True)
        
        'last arm
        If WeaponType(iWeapon) <> WeaponTypeUnarmed Then
            Select Case iUnit
            Case UnitSnakeman
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm2) + iFacing + 3), TempImage)
                Call TempImage.OffsetImage(0, iBobOffset)
            Case Else
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm2) + iFacing), TempImage)
            End Select
        Else
            Select Case iUnit
            Case UnitSnakeman
                Call LoadAndInitBMP(GetUnitFile(iUnit, (8 * iArm2) + iFacing), TempImage)
                Call TempImage.OffsetImage(0, iBobOffset)
            Case Else
                Call LoadAndInitBMP(GetUnitFile(iUnit, iAnimFrame + ((iFacing * 3) + 7 - 1 - iArm1) * 8), TempImage)
                Call TempImage.OffsetImage(0, iBobOffset)
            End Select
        End If
        Call FinalImage.Superimpose(TempImage, True)
    End Select
    
    'if facing the camera, draw weapons last
    If iFacing > 0 And iFacing < 6 Then
        'i'm not convinced that this is precise enough, but we'll see. I think we might need to put the weapon before the last arm for some facings
        Call LoadAndInitBMP(GetWeaponFile(iWeapon, iFacing, bShoot), TempImage)
        Call TempImage.OffsetImage(0, iHandObjectY + iBobOffset)
        Call FinalImage.Superimpose(TempImage, True)
    End If
    
End Sub

Private Sub CreateHumanoid()
    Dim iFacing As Integer
    Dim iAnimFrame As Integer
    Dim iOutputFrame As Integer
    Dim sOutputFile As String
    Dim WeaponFile As String
    Dim sFile As String
    Dim TorsoFile As String
    Dim LeftArmFile As String
    Dim RightArmFile As String
    Dim LegsFile As String
    Dim iWeaponOffsetX As Integer
    Dim HandObjectY As Integer
    Dim iBobOffset As Integer
    sFile = Left$(Profile(ProfileNum).SourceFile, Len(Profile(ProfileNum).SourceFile) - 7)
    sOutputFile = Left$(Profile(ProfileNum).OutputFile, Len(Profile(ProfileNum).OutputFile) - 8)
    'Still frames
    For iFacing = 1 To 8
        HandObjectY = 0
        WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing, 3) & ".bmp")
        Select Case Profile(ProfileNum).UnitType
        Case UnitTypeSectoid, UnitTypeXCom
            If cboxAltTorso.Value = 0 Then
                TorsoFile = sFile & PadNum(32 + iFacing, 3) & ".bmp"
            Else
                TorsoFile = sFile & PadNum(267 + iFacing, 3) & ".bmp"
            End If
            LegsFile = sFile & PadNum(16 + iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case WeaponTypePistol
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(232 + iFacing, 3) & ".bmp"
            Case WeaponTypeHeavy
                LeftArmFile = sFile & PadNum(240 + iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(248 + iFacing, 3) & ".bmp"
            End Select
        Case UnitTypeSnakeman, UnitTypeChrysalid
            TorsoFile = sFile & PadNum(24 + iFacing, 3) & ".bmp"
            LegsFile = sFile & PadNum(16 + iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case WeaponTypePistol
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(99 + iFacing, 3) & ".bmp"
            Case WeaponTypeHeavy
                LeftArmFile = sFile & PadNum(107 + iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(115 + iFacing, 3) & ".bmp"
            End Select
        Case UnitTypeEthereal, UnitTypeZombie
            TorsoFile = sFile & PadNum(iFacing, 3) & ".bmp"
            LegsFile = NullBitmap
            LeftArmFile = NullBitmap
            RightArmFile = NullBitmap
        Case UnitTypeFloater
            TorsoFile = sFile & PadNum(16 + iFacing, 3) & ".bmp"
            LegsFile = NullBitmap
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case WeaponTypePistol
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(67 + iFacing, 3) & ".bmp"
            Case WeaponTypeHeavy
                LeftArmFile = sFile & PadNum(75 + iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(83 + iFacing, 3) & ".bmp"
            End Select
        End Select
        iWeaponOffsetX = 0
        iBobOffset = 0
        If Profile(ProfileNum).UnitType = UnitTypeSectoid Then HandObjectY = HandObjectY + 6
        iOutputFrame = 8 - iFacing
        Call CreateFrame(iFacing, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, HandObjectY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
    Next iFacing
    'Walking frames
    For iFacing = 1 To 8
        WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing, 3) & ".bmp")
        For iAnimFrame = 1 To 8
            HandObjectY = 0
            Select Case Profile(ProfileNum).UnitType
            Case UnitTypeSectoid, UnitTypeXCom
                If cboxAltTorso.Value = 0 Then
                    TorsoFile = sFile & PadNum(32 + iFacing, 3) & ".bmp"
                Else
                    TorsoFile = sFile & PadNum(267 + iFacing, 3) & ".bmp"
                End If
                LegsFile = sFile & PadNum(iAnimFrame + 56 + ((iFacing - 1) * 24), 3) & ".bmp"
                Select Case WeaponType(Profile(ProfileNum).Weapon)
                Case WeaponTypeUnarmed
                    LeftArmFile = sFile & PadNum(iAnimFrame + 40 + ((iFacing - 1) * 24), 3) & ".bmp"
                    RightArmFile = sFile & PadNum(iAnimFrame + 48 + ((iFacing - 1) * 24), 3) & ".bmp"
                Case WeaponTypePistol
                    LeftArmFile = sFile & PadNum(iAnimFrame + 40 + ((iFacing - 1) * 24), 3) & ".bmp"
                    RightArmFile = sFile & PadNum(iFacing + 232, 3) & ".bmp"
                Case WeaponTypeHeavy
                    LeftArmFile = sFile & PadNum(iFacing + 240, 3) & ".bmp"
                    RightArmFile = sFile & PadNum(iFacing + 248, 3) & ".bmp"
                End Select
                iBobOffset = CalculateBobOffset(TorsoFile, LegsFile)
            Case UnitTypeSnakeman
                TorsoFile = sFile & PadNum(24 + iFacing, 3) & ".bmp"
                LegsFile = sFile & PadNum(iAnimFrame + 32 + ((iFacing - 1) * 8), 3) & ".bmp"
                Select Case WeaponType(Profile(ProfileNum).Weapon)
                Case WeaponTypeUnarmed
                    LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                    RightArmFile = sFile & PadNum(iFacing + 8, 3) & ".bmp"
                Case WeaponTypePistol
                    LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                    RightArmFile = sFile & PadNum(iFacing + 99, 3) & ".bmp"
                Case WeaponTypeHeavy
                    LeftArmFile = sFile & PadNum(iFacing + 107, 3) & ".bmp"
                    RightArmFile = sFile & PadNum(iFacing + 115, 3) & ".bmp"
                End Select
                iBobOffset = CalculateBobOffset(TorsoFile, LegsFile)
            Case UnitTypeEthereal, UnitTypeZombie
                TorsoFile = sFile & PadNum(iAnimFrame + (iFacing * 8), 3) & ".bmp"
                LegsFile = NullBitmap
                LeftArmFile = NullBitmap
                RightArmFile = NullBitmap
                iBobOffset = 0
            Case UnitTypeFloater
                If iAnimFrame <= 5 Then 'only 5 walking frames for Floater
                    TorsoFile = sFile & PadNum(24 + ((iFacing - 1) * 5) + iAnimFrame, 3) & ".bmp"
                    LegsFile = NullBitmap
                    Select Case WeaponType(Profile(ProfileNum).Weapon)
                    Case WeaponTypeUnarmed
                        LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                        RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
                    Case WeaponTypePistol
                        LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                        RightArmFile = sFile & PadNum(iFacing + 67, 3) & ".bmp"
                    Case WeaponTypeHeavy
                        LeftArmFile = sFile & PadNum(iFacing + 75, 3) & ".bmp"
                        RightArmFile = sFile & PadNum(iFacing + 83, 3) & ".bmp"
                    End Select
                Else
                    TorsoFile = NullBitmap
                    LegsFile = NullBitmap
                    LeftArmFile = NullBitmap
                    RightArmFile = NullBitmap
                    WeaponFile = NullBitmap
                End If
                Select Case iAnimFrame 'billowing of cape should occur when falling(?)
                Case 1: iBobOffset = 0
                Case 2: iBobOffset = -1
                Case 3: iBobOffset = -2
                Case 4: iBobOffset = -2
                Case 5: iBobOffset = -1
                Case Else: iBobOffset = 0
                End Select
            Case UnitTypeChrysalid
                TorsoFile = sFile & PadNum(24 + iFacing, 3) & ".bmp"
                LegsFile = sFile & PadNum(48 + ((iFacing - 1) * 24) + iAnimFrame, 3) & ".bmp"
                LeftArmFile = sFile & PadNum(32 + ((iFacing - 1) * 24) + iAnimFrame, 3) & ".bmp"
                RightArmFile = sFile & PadNum(40 + ((iFacing - 1) * 24) + iAnimFrame, 3) & ".bmp"
                iBobOffset = CalculateBobOffset(TorsoFile, LegsFile)
            End Select
            iWeaponOffsetX = 0
            If Profile(ProfileNum).UnitType = UnitTypeSectoid Then HandObjectY = HandObjectY + 6
            iOutputFrame = 7 + ((8 - iFacing) * 8) + iAnimFrame
            Call CreateFrame(iFacing, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, HandObjectY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
        Next iAnimFrame
    Next iFacing
    'Shooting frames
    For iFacing = 1 To 8
        HandObjectY = 0
        If WeaponType(Profile(ProfileNum).Weapon) = WeaponTypeHeavy Then
            Select Case iFacing
            Case 7, 8: WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing - 6, 3) & ".bmp")
            Case Else: WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing + 2, 3) & ".bmp")
            End Select
        Else
            WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing, 3) & ".bmp")
        End If
        Select Case Profile(ProfileNum).UnitType
        Case UnitTypeSectoid, UnitTypeXCom
            If cboxAltTorso.Value = 0 Then
                TorsoFile = sFile & PadNum(32 + iFacing, 3) & ".bmp"
            Else
                TorsoFile = sFile & PadNum(267 + iFacing, 3) & ".bmp"
            End If
            LegsFile = sFile & PadNum(16 + iFacing, 3) & ".bmp"
            LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed: RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case Else: RightArmFile = sFile & PadNum(256 + iFacing, 3) & ".bmp"
            End Select
        Case UnitTypeSnakeman, UnitTypeChrysalid
            TorsoFile = sFile & PadNum(24 + iFacing, 3) & ".bmp"
            LegsFile = sFile & PadNum(16 + iFacing, 3) & ".bmp"
            LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed: RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case Else: RightArmFile = sFile & PadNum(123 + iFacing, 3) & ".bmp"
            End Select
        Case UnitTypeEthereal, UnitTypeZombie
            TorsoFile = sFile & PadNum(iFacing, 3) & ".bmp"
            LegsFile = NullBitmap
            LeftArmFile = NullBitmap
            RightArmFile = NullBitmap
        Case UnitTypeFloater
            TorsoFile = sFile & PadNum(16 + iFacing, 3) & ".bmp"
            LegsFile = NullBitmap
            LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed: RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case Else: RightArmFile = sFile & PadNum(91 + iFacing, 3) & ".bmp"
            End Select
        End Select
        iBobOffset = 0
        If Profile(ProfileNum).UnitType = UnitTypeSectoid Then HandObjectY = HandObjectY + 6
        For iAnimFrame = 0 To 5 '6 shooting frames in RA2 - we're just duplicating them here. Add any muzzle effects manually if you want.
            iOutputFrame = 72 + ((8 - iFacing) * 6) + iAnimFrame
            Call CreateFrame(iFacing, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, Profile(ProfileNum).WeaponOffsetY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
        Next iAnimFrame
    Next iFacing
    'Dying frames
    LegsFile = NullBitmap
    LeftArmFile = NullBitmap
    RightArmFile = NullBitmap
    iBobOffset = 0
    WeaponFile = NullBitmap
    If Profile(ProfileNum).UnitType <> UnitTypeZombie Then
        For iAnimFrame = 0 To 2
            For iFacing = 0 To 2 'pad out the dying anim
                Select Case Profile(ProfileNum).UnitType
                Case UnitTypeSectoid: TorsoFile = sFile & PadNum(265 + iAnimFrame, 3) & ".bmp"
                Case UnitTypeFloater: TorsoFile = sFile & PadNum(65 + iAnimFrame, 3) & ".bmp"
                Case UnitTypeSnakeman: TorsoFile = sFile & PadNum(97 + iAnimFrame, 3) & ".bmp"
                Case UnitTypeEthereal: TorsoFile = sFile & PadNum(73 + iAnimFrame, 3) & ".bmp"
                Case UnitTypeChrysalid: TorsoFile = sFile & PadNum(225 + iAnimFrame, 3) & ".bmp"
                Case Else: TorsoFile = NullBitmap
                End Select
                iOutputFrame = 120 + (iAnimFrame * 3) + iFacing '3=the pad amount
                Call CreateFrame(1, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, Profile(ProfileNum).WeaponOffsetY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
            Next iFacing
        Next iAnimFrame
    Else
        iAnimFrame = 0
        Do While iAnimFrame <> 17
            TorsoFile = sFile & PadNum(73 + iAnimFrame, 3) & ".bmp"
            iOutputFrame = 120 + iAnimFrame
            Call CreateFrame(1, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, Profile(ProfileNum).WeaponOffsetY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
        Loop
    End If
    If FileExists(sFile & "_DEAD.bmp") Then
        'generate initial dead body - later on we will manually create the decompose frames (or maybe a future version of this program will do it)
        TorsoFile = sFile & "_DEAD.bmp"
        iOutputFrame = -999
        Call CreateFrame(1, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, Profile(ProfileNum).WeaponOffsetY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
    End If
    'Crouching frames
    If cboxCrouch.Value = 1 And Profile(ProfileNum).UnitType = UnitTypeSectoid Then
        'idle
        For iFacing = 1 To 8
            HandObjectY = 0 'boboffset is added to this, else we'd set it to 4.
            WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing, 3) & ".bmp")
            If cboxAltTorso.Value = 0 Then
                TorsoFile = sFile & PadNum(32 + iFacing, 3) & ".bmp"
            Else
                TorsoFile = sFile & PadNum(267 + iFacing, 3) & ".bmp"
            End If
            LegsFile = sFile & PadNum(24 + iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case WeaponTypePistol
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(232 + iFacing, 3) & ".bmp"
            Case WeaponTypeHeavy
                LeftArmFile = sFile & PadNum(240 + iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(248 + iFacing, 3) & ".bmp"
            End Select
            iWeaponOffsetX = 0
            If Profile(ProfileNum).UnitType = UnitTypeSectoid Then HandObjectY = HandObjectY + 6
            iBobOffset = 4
            iOutputFrame = 128 + (8 - iFacing)
            Call CreateFrame(iFacing, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, HandObjectY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
        Next iFacing
        'shooting
        For iFacing = 1 To 8
            If WeaponType(Profile(ProfileNum).Weapon) = WeaponTypeHeavy Then
                Select Case iFacing
                Case 7, 8: WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing - 6, 3) & ".bmp")
                Case Else: WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing + 2, 3) & ".bmp")
                End Select
            Else
                WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing, 3) & ".bmp")
            End If
            If cboxAltTorso.Value = 0 Then
                TorsoFile = sFile & PadNum(32 + iFacing, 3) & ".bmp"
            Else
                TorsoFile = sFile & PadNum(267 + iFacing, 3) & ".bmp"
            End If
            LegsFile = sFile & PadNum(24 + iFacing, 3) & ".bmp"
            LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed: RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case Else: RightArmFile = sFile & PadNum(256 + iFacing, 3) & ".bmp"
            End Select
            iBobOffset = 4
            For iAnimFrame = 0 To 5 '6 shooting frames in RA2 - we're just duplicating them here. Add any muzzle effects manually if you want.
                iOutputFrame = 136 + ((8 - iFacing) * 6) + iAnimFrame
                Call CreateFrame(iFacing, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, Profile(ProfileNum).WeaponOffsetY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
            Next iAnimFrame
        Next iFacing
    End If
    'Flying frames
    If cboxFlying.Value = 1 And Profile(ProfileNum).UnitType = UnitTypeSectoid Then
        'idle AND walking (for no-bob idle, just use first frame)
        For iFacing = 1 To 8
            WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing, 3) & ".bmp")
            If cboxAltTorso.Value = 0 Then
                TorsoFile = sFile & PadNum(32 + iFacing, 3) & ".bmp"
            Else
                TorsoFile = sFile & PadNum(267 + iFacing, 3) & ".bmp"
            End If
            LegsFile = sFile & PadNum(275 + iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case WeaponTypePistol
                LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(232 + iFacing, 3) & ".bmp"
            Case WeaponTypeHeavy
                LeftArmFile = sFile & PadNum(240 + iFacing, 3) & ".bmp"
                RightArmFile = sFile & PadNum(248 + iFacing, 3) & ".bmp"
            End Select
            iWeaponOffsetX = 0
            For iAnimFrame = 0 To 5
                Select Case iAnimFrame
                Case 0: iBobOffset = 0 'for flying this is whole body bob, not just torso bob
                Case 1: iBobOffset = 1
                Case 2: iBobOffset = 2
                Case 3: iBobOffset = 1
                Case 4: iBobOffset = 0
                Case 5: iBobOffset = -1
                End Select
                iOutputFrame = 184 + ((8 - iFacing) * 6) + iAnimFrame
                Call CreateFrame(iFacing, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, 0, Profile(ProfileNum).WeaponOffsetY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp", iBobOffset)
            Next iAnimFrame
        Next iFacing
        'shooting
        For iFacing = 1 To 8
            If WeaponType(Profile(ProfileNum).Weapon) = WeaponTypeHeavy Then
                Select Case iFacing
                Case 7, 8: WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing - 6, 3) & ".bmp")
                Case Else: WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing + 2, 3) & ".bmp")
                End Select
            Else
                WeaponFile = JoinPath(RESDIR, "weapons\" & comboWeapon.Text & PadNum(iFacing, 3) & ".bmp")
            End If
            If cboxAltTorso.Value = 0 Then
                TorsoFile = sFile & PadNum(32 + iFacing, 3) & ".bmp"
            Else
                TorsoFile = sFile & PadNum(267 + iFacing, 3) & ".bmp"
            End If
            LegsFile = sFile & PadNum(275 + iFacing, 3) & ".bmp"
            LeftArmFile = sFile & PadNum(iFacing, 3) & ".bmp"
            Select Case WeaponType(Profile(ProfileNum).Weapon)
            Case WeaponTypeUnarmed: RightArmFile = sFile & PadNum(8 + iFacing, 3) & ".bmp"
            Case Else: RightArmFile = sFile & PadNum(256 + iFacing, 3) & ".bmp"
            End Select
            iBobOffset = 0
            For iAnimFrame = 0 To 5 '6 shooting frames in RA2 - we're just duplicating them here. Add any muzzle effects manually if you want.
                iOutputFrame = 232 + ((8 - iFacing) * 6) + iAnimFrame
                Call CreateFrame(iFacing, TorsoFile, LegsFile, WeaponFile, LeftArmFile, RightArmFile, iBobOffset, Profile(ProfileNum).WeaponOffsetY, iWeaponOffsetX, sOutputFile & PadNum(iOutputFrame, 4) & ".bmp")
            Next iAnimFrame
        Next iFacing
    End If
End Sub

Private Function CalculateBobOffset(ByVal TorsoFile As String, ByVal LegsFile As String)
'looks like some images have sidey bits so taking the linkage point to be dead center (i.e. X=15)
    Dim TempImage As MarshallxImageClass
    Dim X As Integer
    'Dim bOk As Boolean
    Dim TorsoBottom As Integer
    Dim LegsTop As Integer
    Set TempImage = New MarshallxImageClass
    Call TempImage.LoadBMP(TorsoFile)
    TorsoBottom = TempImage.Height - 1
    Do While TorsoBottom > 0
        'bOk = False
        'X = 0
        'Do While X < tempimage.Width
            If TempImage.ImageData(15, TorsoBottom).Index <> 254 Then
                'bOk = True
                Exit Do
            End If
            'X = X + 1
        'Loop
        'If bOk Then Exit Do
        TorsoBottom = TorsoBottom - 1
    Loop
    Call TempImage.LoadBMP(LegsFile)
    LegsTop = 0
    Do While LegsTop < TempImage.Height
        'bOk = False
        'X = 0
        'Do While X < tempimage.Width
            If TempImage.ImageData(15, LegsTop).Index <> 254 Then
                'bOk = True
                Exit Do
            End If
            'X = X + 1
        'Loop
        'If bOk Then Exit Do
        LegsTop = LegsTop + 1
    Loop
    CalculateBobOffset = (LegsTop - TorsoBottom) - 1
End Function

Private Sub CreateFrame(ByVal iFacing As Integer, ByVal TorsoFile As String, ByVal LegsFile As String, ByVal WeaponFile As String, ByVal LeftArmFile As String, ByVal RightArmFile As String, ByVal iBobOffset As Integer, ByVal iWeaponOffsetY As Integer, ByVal iWeaponOffsetX As Integer, ByVal OutputFile As String, Optional ByVal FullBodyBobOffset As Integer = 0)
    Dim OutImage As MarshallxImageClass
    Dim ConvertPaletteAllowedSlots() As Integer
    Dim iCounter As Integer
    Set OutImage = New MarshallxImageClass
    Call OutImage.LoadBMP(TorsoFile) 'any file will do to get the palette
    Call OutImage.SetBackgroundColorByIndex(254)
    Call OutImage.ClearCanvas
    Call OutImage.SizeCanvas(32, 40)
    Select Case iFacing
    Case 8, 1
        Call CreateFrame_EachPart(OutImage, WeaponFile, iWeaponOffsetY + iBobOffset, iWeaponOffsetX)
        Call CreateFrame_EachPart(OutImage, LeftArmFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, LegsFile, 0)
        Call CreateFrame_EachPart(OutImage, TorsoFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, RightArmFile, iBobOffset)
    Case 2, 3
        Call CreateFrame_EachPart(OutImage, LeftArmFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, LegsFile, 0)
        Call CreateFrame_EachPart(OutImage, TorsoFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, WeaponFile, iWeaponOffsetY + iBobOffset, iWeaponOffsetX)
        Call CreateFrame_EachPart(OutImage, RightArmFile, iBobOffset)
    Case 4, 5
        Call CreateFrame_EachPart(OutImage, RightArmFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, LegsFile, 0)
        Call CreateFrame_EachPart(OutImage, TorsoFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, LeftArmFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, WeaponFile, iWeaponOffsetY + iBobOffset, iWeaponOffsetX)
    Case 6, 7
        Call CreateFrame_EachPart(OutImage, RightArmFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, WeaponFile, iWeaponOffsetY + iBobOffset, iWeaponOffsetX)
        Call CreateFrame_EachPart(OutImage, LegsFile, 0)
        Call CreateFrame_EachPart(OutImage, TorsoFile, iBobOffset)
        Call CreateFrame_EachPart(OutImage, LeftArmFile, iBobOffset)
    End Select
    'enlarge canvas
    Call OutImage.SizeCanvas(94, 106)
    Call OutImage.OffsetImage(31, 21 + FullBodyBobOffset)
    'convert palette
    'first, limit the source palette to VGA values (that's all RA2 can have)
    Call OutImage.LimitPaletteToVGA
    Call OutImage.SavePalette(JoinPath(App.Path, "vga_ufo.pal"), "JASC") 'TEMPORARY!
    'conversion options - what palette slots can we match against?
    ReDim ConvertPaletteAllowedSlots(255)
    For iCounter = 0 To 15
        ConvertPaletteAllowedSlots(iCounter) = PaletteMatchNone
    Next iCounter
    For iCounter = 16 To 31
        If cboxRemapClose.Value = 1 Then
            ConvertPaletteAllowedSlots(iCounter) = PaletteMatchAll
        ElseIf cboxRemapExact.Value = 1 Then
            ConvertPaletteAllowedSlots(iCounter) = PaletteMatchExact
        Else
            ConvertPaletteAllowedSlots(iCounter) = PaletteMatchNone
        End If
    Next iCounter
    For iCounter = 240 To 255
        ConvertPaletteAllowedSlots(iCounter) = PaletteMatchNone
    Next iCounter
    For iCounter = 32 To 239
        ConvertPaletteAllowedSlots(iCounter) = PaletteMatchAll
    Next iCounter
    If optPal(1).Value = True Then
        'ra2 palette
        Call OutImage.LoadPalette(JoinPath(App.Path, "ra2.pal"), ConvertPaletteAllowedSlots(), "JASC", ConvertMethodNearestColor)
    ElseIf optPal(2).Value = True Then
        'combo palette
        Call OutImage.LoadPalette(JoinPath(App.Path, "combo.pal"), ConvertPaletteAllowedSlots(), "JASC", ConvertMethodNearestColor)
    End If
    If cboxRA2BG.Value = 1 Then Call OutImage.SetBackgroundColorByIndex(0, True)
    'save the completed frame
    Call OutImage.SaveBMP(OutputFile)
End Sub

Private Sub CreateFrame_EachPart(ByRef OutImage As MarshallxImageClass, ByVal sSuperimposeFile As String, ByVal iOffsetY As Integer, Optional ByVal iOffsetX As Integer = 0)
    Dim SuperimposeImage As MarshallxImageClass
    Set SuperimposeImage = New MarshallxImageClass
    Call SuperimposeImage.LoadBMP(sSuperimposeFile)
    Call SuperimposeImage.SetTransparentColorByIndex(254)
    SuperimposeImage.BackgroundColor = SuperimposeImage.TransparentColor
    Call SuperimposeImage.SizeCanvas(32, 40)
    Call SuperimposeImage.OffsetImage(iOffsetX, iOffsetY)
    Call OutImage.Superimpose(SuperimposeImage, True)
End Sub

Private Sub cmdOutputFile_Click()
    dialogOpen.FileName = txtOutputFile.Text
    dialogOpen.DialogTitle = "Select Output File (any frame)"
'RetryOpen:
    On Error GoTo CancelOpen
    dialogOpen.ShowOpen
    On Error GoTo 0
    txtOutputFile.Text = dialogOpen.FileName
CancelOpen:
End Sub

Private Sub cmdSourceFile_Click()
    dialogOpen.FileName = txtSourceFile.Text
    dialogOpen.DialogTitle = "Select Source File (any frame)"
'RetryOpen:
    On Error GoTo CancelOpen
    dialogOpen.ShowOpen
    On Error GoTo 0
    txtSourceFile.Text = dialogOpen.FileName
    Call UpdateReadyStatus
CancelOpen:
End Sub

Private Sub comboOutputSeq_Click()
    Set imageOutput.Picture = Nothing
    If comboOutputSeq.ListIndex <> 0 Then
        If FileExists(JoinPath(comboOutputSeq.Tag, comboOutputSeq.List(comboOutputSeq.ListIndex))) Then
            imageOutput.Picture = LoadPicture(JoinPath(comboOutputSeq.Tag, comboOutputSeq.List(comboOutputSeq.ListIndex)))
        End If
    End If
End Sub

Private Sub Form_Load()
    Call Init
End Sub

Private Sub txtOutputFile_Change()
    Call UpdateOutputSequence
End Sub

Private Sub UpdateOutputSequence()
    Dim sFile As String
    Dim sPath As String
    Dim sExt As String
    Dim iCounter As Integer
    Call comboOutputSeq.Clear
    Call comboOutputSeq.AddItem(" ")
    comboOutputSeq.Tag = ""
    Call SplitPath(txtOutputFile.Text, sFile, sPath)
    If DirExists(sPath) Then
        sExt = FileType(sFile)
        sFile = StripExtension(sFile)
        If Len(sFile) >= 5 Then 'RA2 frame index is 1 space + 4 digits
            lstFiles.Path = sPath
            comboOutputSeq.Tag = sPath
            lstFiles.FileName = Left$(sFile, Len(sFile) - 5) & "*." & sExt
            Call lstFiles.Refresh
            For iCounter = 0 To lstFiles.ListCount - 1
                If Left$(lstFiles.List(iCounter), Len(sFile) - 5) = Left$(sFile, Len(sFile) - 5) Then
                    Call comboOutputSeq.AddItem(lstFiles.List(iCounter))
                End If
            Next iCounter
        End If
    End If
End Sub

